package
{
	import flash.display.Bitmap;
	import flash.display.BitmapData;
	import flash.display.Loader;
	import flash.events.Event;
	import flash.events.MouseEvent;
	import flash.net.FileReference;
	import flash.system.Security;
	import flash.utils.ByteArray;
	import flash.external.ExternalInterface;
	import org.flixel.*;
	import flash.system.Capabilities;
	
	public class TitleState extends FlxState
	{
		override public function create():void
		{
			if(FlxG.stage != null)
				FlxG.stage.addEventListener(MouseEvent.MOUSE_DOWN, onMouseDown);
			bgColor = 0xFFEEEEFF;
			var title:FlxText = new FlxText(0,25,FlxG.width,"Brittle Paint");
			title.size=8;
			title.alignment="center";		
			title.color=0xff000000;
			add(title); //adds a 100px wide text field at position 0,0 (upper left)
			var subtitle:FlxText = new FlxText(0,FlxG.height/2+5,FlxG.width,"click to load a file");
			subtitle.alignment="center";
			subtitle.color=0xff000000;
			subtitle.size=8;
			FlxG.level=0;
			add(subtitle);
		}
		
		override public function update():void
		{
		}
		
		override public function destroy():void
		{
			if(FlxG.stage != null)
				FlxG.stage.removeEventListener(MouseEvent.MOUSE_DOWN, onMouseDown);
			super.destroy();
		}
		
		public function onMouseDown(event:MouseEvent):void
		{
			//Security.allowDomain("http://ded.increpare.com");
			load();
		}
		
		
		private var file:FileReference;
		
		private function load (): void
		{
			file = new FileReference();
			file.addEventListener(Event.SELECT, fileSelect);
			file.browse();
		}
		
		private function fileSelect (event:Event):void {
			//file = FileReference(event.target);
			file.addEventListener(Event.COMPLETE, loadComplete);
			file.load();
		}

		public var files:Array = [];
		public var loaders:Array = [];

		private function loadComplete (event:Event):void {
			var loader:Loader = new Loader();
			files.push(event.target);
			loaders.push(loader);
			
			
			loader.contentLoaderInfo.addEventListener(Event.COMPLETE, onDataLoadComplete);
			loader.loadBytes(FileReference(event.target).data);		
		}
		
		private function onDataLoadComplete(e:Event):void
		{
			var bitmapData:BitmapData = Bitmap(e.target.content).bitmapData;
			var loader:Loader = Loader(e.target.loader);
			var index:Number = loaders.indexOf(loader);
			var file:String = FileReference(files[index]).name;
			/*
			* Clear the arrays to get rid of unwanted references that might 
			* prevent them from being garbage collected.
			* */
			files.splice(index);
			loaders.splice(index);
			
			GameState.srcImage=bitmapData;
			
			file=null;
			files=null;
			bitmapData=null;
			loaders=null;
			files=null;

			if (Capabilities.os.indexOf("Mac OS 10.6") != -1)
			{
				if(ExternalInterface.available)
				{
					ExternalInterface.call("alert", "You’re seeing this dialog box because there is a Flash Player error in Mac OS 10.6 that can only be fixed by clicking on another window, so help me out and click OK!");
				}
			}
			
			FlxG.state = new GameState();
		}

	}
}